import { TreeReconstructed } from '@/lib/XMLProcessor/src/typing'

export function reconstructTree(data: TreeReconstructed[]): string {
    const doc = new Document()
    let root: any
    for (let i = 0; i < data.length; i++) {
        if (i===0) {
            root = doc.createElement(data[i].label)
            root.setAttribute('data-key', data[i].key)
            root.setAttribute('data-indent-level', data[i].chained.length.toString())
            root.setAttribute('data-w-e-type', data[i].label)
            doc.appendChild(root)
        } else {
            const nv = doc.createElement(data[i].label)
            nv.setAttribute('data-key', data[i].key)
            nv.setAttribute('data-indent-level', data[i].chained.length.toString())
            nv.setAttribute('data-w-e-type', data[i].label)
            if (data[i].type) {
                nv.setAttribute('data-modify-type', data[i].type)
            }
            if (data[i].label === 'PARA' || data[i].label === 'TITLE') {
                nv.textContent = data[i].textContent
            }
            root.appendChild(nv)
        }
    }

    // Serialize to XML string
    const serializer = new XMLSerializer()
    return serializer.serializeToString(doc)
}